<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Security-Policy" content="default-src *; style-src 'self' http://* 'unsafe-inline'; script-src 'self' http://* 'unsafe-inline' 'unsafe-eval'" />
    <title>VLC launcher</title>
</head>
<body>
    <form method="POST" action="/" id="form">
        <p>Paste Youtube URL here (and press Enter) and it'll start playing on the Raspberry Pi:</p>
        <input type="text" name="url" id="url" style="width: 400px" autocomplete="off" autofocus>
        <p id="notification"></p>
        <p>VLC instances (PID):</p>
        <div id="playing"></div>
        <div><input type="button" name="play-pause" onclick="pp()" value="Play/pause" style="margin-top: 1em;"></div>
    </form>
<script type="text/javascript">
    checkPlaying()

    document.getElementById('form').onsubmit = ship

    document.getElementById('url').addEventListener('keypress', function(event) {
        if (event.key === 'Enter') {
            event.preventDefault()
            ship()
        }
    })

    function ajax(method, path, data, callback) {
        var xhr = new XMLHttpRequest()
        xhr.open(method, path, true)
        xhr.setRequestHeader('Content-type', 'application/json')
        xhr.onreadystatechange = function () {
            if (xhr.readyState === 4 && xhr.status === 200) {
                callback(xhr.responseText)
            }
        }
        xhr.send(data)
    }

    function ship(event) {
        let payload = {}
        payload.url = document.getElementById('url').value
        console.log(`Let\'s try to ship ${payload.url} to the RPi...`)
        ajax('POST', '/', JSON.stringify(payload), function(response) {
            console.log(response)
            document.getElementById('url').value = ""
            document.getElementById('notification').innerHTML = `Opening ${payload.url} in VLC, sit tight...`
            setTimeout(function() {
                checkPlaying()
                document.getElementById('notification').innerHTML = ''
            }, 5000)
        })
    }

    function kill(pid) {
        ajax('GET', '/kill/' + pid, '', function(response) {
            console.log(response)
        })
    }

    function pp(pid) {
        ajax('GET', '/play-pause', '', function(response) {
            console.log(response)
        })
    }

    let intervalID = window.setInterval(checkPlaying, 3000)

    function checkPlaying() {
        ajax('GET', '/playing', '', function(response) {
            response = JSON.parse(response)
            document.getElementById('playing').innerHTML = ''
            response.forEach(function(pid) {
                document.getElementById('playing').innerHTML += '<div>' + pid + ' (<a href="javascript:void(0)" onclick="kill(' + pid + ')">Kill</a>)</div>'
            })
        })
    }

    
    
</script>
</body>
</html>
